MemberRefEntry (Java SE 26 & JDK 26)
Description: declaration: module: java.base, package: java.lang.classfile.constantpool, interface: MemberRefEntry
Keywords: java.lang.classfile.constantpool.MemberRefEntry interface

# Interface MemberRefEntry

All Superinterfaces:
  `PoolEntry`

All Known Subinterfaces:
  `FieldRefEntry, InterfaceMethodRefEntry, MethodRefEntry`

public sealed interface MemberRefEntry extends PoolEntry permits FieldRefEntry, InterfaceMethodRefEntry, MethodRefEntry (not exhaustive)
Superinterface modeling symbolic references to a member of a class or interface in the constant pool of a `class` file, which include references to fields, class methods, and interface methods.

Different types of symbolic references to a member of a class or interface bear structural similarities and share parts of the resolution processes, and they can sometimes appear in the same locations. For example, both `MethodRefEntry` and `InterfaceMethodRefEntry` can appear in an `invokestatic` instruction.

A member reference entry is composite:

    MemberRefEntry(
        ClassEntry owner,
        NameAndTypeEntry nameAndType
    )

See Java Virtual Machine Specification:
  4.4.2 The `CONSTANT_Fieldref_info`, `CONSTANT_Methodref_info`, and `CONSTANT_InterfaceMethodref_info` Structures
Sealed Class Hierarchy Graph:
Since:
  24

- ## Field Summary

  ### Fields declared in interface PoolEntry

  `TAG_CLASS, TAG_DOUBLE, TAG_DYNAMIC, TAG_FIELDREF, TAG_FLOAT, TAG_INTEGER, TAG_INTERFACE_METHODREF, TAG_INVOKE_DYNAMIC, TAG_LONG, TAG_METHOD_HANDLE, TAG_METHOD_TYPE, TAG_METHODREF, TAG_MODULE, TAG_NAME_AND_TYPE, TAG_PACKAGE, TAG_STRING, TAG_UTF8`
  Modifier and Type
  Field
  Description
  `static final int`
  `TAG_CLASS`
  The tag for `CONSTANT_Class` constant kind.
  `static final int`
  `TAG_DOUBLE`
  The tag for `CONSTANT_Double` constant kind.
  `static final int`
  `TAG_DYNAMIC`
  The tag for `CONSTANT_Dynamic` constant kind.
  `static final int`
  `TAG_FIELDREF`
  The tag for `CONSTANT_Fieldref` constant kind.
  `static final int`
  `TAG_FLOAT`
  The tag for `CONSTANT_Float` constant kind.
  `static final int`
  `TAG_INTEGER`
  The tag for `CONSTANT_Integer` constant kind.
  `static final int`
  `TAG_INTERFACE_METHODREF`
  The tag for `CONSTANT_InterfaceMethodref` constant kind.
  `static final int`
  `TAG_INVOKE_DYNAMIC`
  The tag for `CONSTANT_InvokeDynamic` constant kind.
  `static final int`
  `TAG_LONG`
  The tag for `CONSTANT_Long` constant kind.
  `static final int`
  `TAG_METHOD_HANDLE`
  The tag for `CONSTANT_MethodHandle` constant kind.
  `static final int`
  `TAG_METHOD_TYPE`
  The tag for `CONSTANT_MethodType` constant kind.
  `static final int`
  `TAG_METHODREF`
  The tag for `CONSTANT_Methodref` constant kind.
  `static final int`
  `TAG_MODULE`
  The tag for `CONSTANT_Module` constant kind.
  `static final int`
  `TAG_NAME_AND_TYPE`
  The tag for `CONSTANT_NameAndType` constant kind.
  `static final int`
  `TAG_PACKAGE`
  The tag for `CONSTANT_Package` constant kind.
  `static final int`
  `TAG_STRING`
  The tag for `CONSTANT_String` constant kind.
  `static final int`
  `TAG_UTF8`
  The tag for `CONSTANT_Utf8` constant kind.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `default Utf8Entry`
  `name()`
  Returns the name of the member.
  `NameAndTypeEntry`
  `nameAndType()`
  Returns the name and descriptor string of the member.
  `ClassEntry`
  `owner()`
  Returns the class or interface which this member belongs to.
  `default Utf8Entry`
  `type()`
  Returns the descriptor string of the member.

  ### Methods declared in interface PoolEntry

  `constantPool, index, tag, width`
  Modifier and Type
  Method
  Description
  `ConstantPool`
  `constantPool()`
  Returns the constant pool this entry is from.
  `int`
  `index()`
  Returns the index within the constant pool corresponding to this entry.
  `int`
  `tag()`
  Returns the constant pool tag that describes the type of this entry.
  `int`
  `width()`
  Returns the number of constant pool slots this entry consumes.

- ## Method Details

  - ### owner

    ClassEntry owner()
    Returns the class or interface which this member belongs to.
    Returns:
      the class or interface which this member belongs to

  - ### nameAndType

    NameAndTypeEntry nameAndType()
    Returns the name and descriptor string of the member.
    Returns:
      the name and descriptor string of the member

  - ### name

    default Utf8Entry name()
    Returns the name of the member.
    Returns:
      the name of the member

  - ### type

    default Utf8Entry type()
    Returns the descriptor string of the member. This is a field descriptor string if this entry is a `FieldRefEntry`, or a method descriptor string if this entry is a `MethodRefEntry` or `InterfaceMethodRefEntry`.
    API Note:
      Each subinterface defines a `typeSymbol()` accessor for the symbolic descriptor for the member type.
    Returns:
      the descriptor string of the member